# Interface CyberDeepClientInstance<L>

interface CyberDeepClientInstance<L> {
DeepClient: typeof DeepClient;
DeepContext: Context<DeepClient<Link<Id>>>;
DeepProvider: ((__namedParameters: {
apolloClient?: IApolloClient<any>;
children: any;
minilinks?: MinilinkCollection<MinilinksGeneratorOptions, Link<Id>>;
namespace?: string;
}) => Element);
apolloClient: IApolloClient<any>;
deep: DeepClientInstance<L>;
defaultDeleteName?: string;
defaultInsertName?: string;
defaultSelectName?: string;
defaultUpdateName?: string;
deleteReturning?: string;
eval: ((options: {
context?: Id[];
handlerId?: Id;
input?: any;
linkId?: Id;
value?: string;
}) => Promise<{
data?: any;
error?: any;
}>);
filesSelectReturning?: string;
handleAuth?: ((linkId?: Id, token?: string) => any);
insertReturning?: string;
linkId?: Id;
linksSelectReturning?: string;
minilinks: MinilinksResult<L>;
namespace?: string;
returning?: string;
selectReturning?: string;
selectorsSelectReturning?: string;
table?: string;
token?: string;
unsafe?: any;
updateReturning?: string;
useDeep: (() => DeepClient<Link<Id>>);
useDeepId: ((start: QueryLink | DeepClientStartItem, ...path: DeepClientPathItem[]) => {
data: Id;
error?: any;
loading: boolean;
});
useDeepQuery: (<Table, LL>(query: Exp<Table>, options?: Options<Table>) => {
data?: LL[];
error?: any;
loading: boolean;
});
useDeepSubscription: (<Table, LL>(query: Exp<Table>, options?: Options<Table>) => UseDeepSubscriptionResult<LL>);
useMinilinksQuery: ((query: Exp<"links">) => L[]);
useMinilinksSubscription: ((query: Exp<"links">) => L[]);
valuesSelectReturning?: string;
Traveler(links: Link<Id>[]): Traveler;
await(id: Id): Promise<boolean>;
can(objectIds: Id[], subjectIds: Id[], actionIds: Id[]): Promise<boolean>;
delete<TTable>(exp: Exp<TTable>, options?: WriteOptions<TTable>): Promise<DeepClientResult<{
id: any;
}[]>>;
guest(options: DeepClientGuestOptions): Promise<DeepClientAuthResult>;
id(start:
| string
| number
| QueryLink
| Id[], ...path: DeepClientPathItem[]): Promise<Id>;
idLocal(start: DeepClientStartItem, ...path: DeepClientPathItem[]): Id;
insert<TTable, LL>(objects: InsertObjects<TTable>, options?: WriteOptions<TTable>): Promise<DeepClientResult<{
id: any;
}[]>>;
jwt(options: DeepClientJWTOptions): Promise<DeepClientAuthResult>;
login(options: DeepClientJWTOptions): Promise<DeepClientAuthResult>;
logout(): Promise<DeepClientAuthResult>;
reserve<LL>(count: number): Promise<Id[]>;
select<TTable, LL>(exp: Exp<TTable>, options?: ReadOptions<TTable>): Promise<DeepClientResult<number | LL[]>>;
serial(options: AsyncSerialParams): Promise<DeepClientResult<{
id: any;
}[]>>;
serializeQuery(exp: any, env?: string): any;
serializeWhere(exp: any, env?: string): any;
stringify(any?: any): string;
subscribe<TTable, LL>(exp: Exp<TTable>, options?: ReadOptions<TTable>): Observable<number | LL[]>;
unvertualizeId(id: Id): Id;
update<TTable>(exp: Exp<TTable>, value: UpdateValue<TTable>, options?: WriteOptions<TTable>): Promise<DeepClientResult<{
id: any;
}[]>>;
}

#### Type Parameters

- L extends Link<Id> = Link<Id>

#### Hierarchy (view full)

- DeepClientInstance<L>
  - CyberDeepClientInstance

#### Implemented by

- CyberDeepClient

- Defined in work/deeplinks/deeplinks/imports/cyber.tsx:162

#####
Index

### Properties

DeepClient
DeepContext
DeepProvider
apolloClient
deep
defaultDeleteName?
defaultInsertName?
defaultSelectName?
defaultUpdateName?
deleteReturning?
eval
filesSelectReturning?
handleAuth?
insertReturning?
linkId?
linksSelectReturning?
minilinks
namespace?
returning?
selectReturning?
selectorsSelectReturning?
table?
token?
unsafe?
updateReturning?
useDeep
useDeepId
useDeepQuery
useDeepSubscription
useMinilinksQuery
useMinilinksSubscription
valuesSelectReturning?

### Methods

Traveler
await
can
delete
guest
id
idLocal
insert
jwt
login
logout
reserve
select
serial
serializeQuery
serializeWhere
stringify
subscribe
unvertualizeId
update

##
Properties

### DeepClient

DeepClient: typeof DeepClient

Inherited from DeepClientInstance.DeepClient

- Defined in work/deeplinks/deeplinks/imports/client.tsx:372

### DeepContext

DeepContext: Context<DeepClient<Link<Id>>>

Inherited from DeepClientInstance.DeepContext

- Defined in work/deeplinks/deeplinks/imports/client.tsx:437

### DeepProvider

DeepProvider: ((__namedParameters: {
apolloClient?: IApolloClient<any>;
children: any;
minilinks?: MinilinkCollection<MinilinksGeneratorOptions, Link<Id>>;
namespace?: string;
}) => Element)

Inherited from DeepClientInstance.DeepProvider

- Defined in work/deeplinks/deeplinks/imports/client.tsx:436

### apolloClient

apolloClient: IApolloClient<any>

Inherited from DeepClientInstance.apolloClient

- Defined in work/deeplinks/deeplinks/imports/client.tsx:374

### deep

deep: DeepClientInstance<L>

Inherited from DeepClientInstance.deep

- Defined in work/deeplinks/deeplinks/imports/client.tsx:371

### `Optional` defaultDeleteName

defaultDeleteName?: string

Inherited from DeepClientInstance.defaultDeleteName

- Defined in work/deeplinks/deeplinks/imports/client.tsx:391

### `Optional` defaultInsertName

defaultInsertName?: string

Inherited from DeepClientInstance.defaultInsertName

- Defined in work/deeplinks/deeplinks/imports/client.tsx:389

### `Optional` defaultSelectName

defaultSelectName?: string

Inherited from DeepClientInstance.defaultSelectName

- Defined in work/deeplinks/deeplinks/imports/client.tsx:388

### `Optional` defaultUpdateName

defaultUpdateName?: string

Inherited from DeepClientInstance.defaultUpdateName

- Defined in work/deeplinks/deeplinks/imports/client.tsx:390

### `Optional` deleteReturning

deleteReturning?: string

Inherited from DeepClientInstance.deleteReturning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:386

### eval

eval: ((options: {
context?: Id[];
handlerId?: Id;
input?: any;
linkId?: Id;
value?: string;
}) => Promise<{
data?: any;
error?: any;
}>)

Inherited from DeepClientInstance.eval

- Defined in work/deeplinks/deeplinks/imports/client.tsx:441

### `Optional` filesSelectReturning

filesSelectReturning?: string

Inherited from DeepClientInstance.filesSelectReturning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:383

### `Optional` handleAuth

handleAuth?: ((linkId?: Id, token?: string) => any)

Inherited from DeepClientInstance.handleAuth

- Defined in work/deeplinks/deeplinks/imports/client.tsx:369

### `Optional` insertReturning

insertReturning?: string

Inherited from DeepClientInstance.insertReturning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:384

### `Optional` linkId

linkId?: Id

Inherited from DeepClientInstance.linkId

- Defined in work/deeplinks/deeplinks/imports/client.tsx:367

### `Optional` linksSelectReturning

linksSelectReturning?: string

Inherited from DeepClientInstance.linksSelectReturning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:380

### minilinks

minilinks: MinilinksResult<L>

Inherited from DeepClientInstance.minilinks

- Defined in work/deeplinks/deeplinks/imports/client.tsx:375

### `Optional` namespace

namespace?: string

Inherited from DeepClientInstance.namespace

- Defined in work/deeplinks/deeplinks/imports/client.tsx:365

### `Optional` returning

returning?: string

Inherited from DeepClientInstance.returning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:377

### `Optional` selectReturning

selectReturning?: string

Inherited from DeepClientInstance.selectReturning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:379

### `Optional` selectorsSelectReturning

selectorsSelectReturning?: string

Inherited from DeepClientInstance.selectorsSelectReturning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:382

### `Optional` table

table?: string

Inherited from DeepClientInstance.table

- Defined in work/deeplinks/deeplinks/imports/client.tsx:376

### `Optional` token

token?: string

Inherited from DeepClientInstance.token

- Defined in work/deeplinks/deeplinks/imports/client.tsx:368

### `Optional` unsafe

unsafe?: any

Inherited from DeepClientInstance.unsafe

- Defined in work/deeplinks/deeplinks/imports/client.tsx:393

### `Optional` updateReturning

updateReturning?: string

Inherited from DeepClientInstance.updateReturning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:385

### useDeep

useDeep: (() => DeepClient<Link<Id>>)

Inherited from DeepClientInstance.useDeep

- Defined in work/deeplinks/deeplinks/imports/client.tsx:435

### useDeepId

useDeepId: ((start: QueryLink | DeepClientStartItem, ...path: DeepClientPathItem[]) => {
data: Id;
error?: any;
loading: boolean;
})

Inherited from DeepClientInstance.useDeepId

- Defined in work/deeplinks/deeplinks/imports/client.tsx:430

### useDeepQuery

useDeepQuery: (<Table, LL>(query: Exp<Table>, options?: Options<Table>) => {
data?: LL[];
error?: any;
loading: boolean;
})

Inherited from DeepClientInstance.useDeepQuery

- Defined in work/deeplinks/deeplinks/imports/client.tsx:432

### useDeepSubscription

useDeepSubscription: (<Table, LL>(query: Exp<Table>, options?: Options<Table>) => UseDeepSubscriptionResult<LL>)

Inherited from DeepClientInstance.useDeepSubscription

- Defined in work/deeplinks/deeplinks/imports/client.tsx:431

### useMinilinksQuery

useMinilinksQuery: ((query: Exp<"links">) => L[])

Inherited from DeepClientInstance.useMinilinksQuery

- Defined in work/deeplinks/deeplinks/imports/client.tsx:433

### useMinilinksSubscription

useMinilinksSubscription: ((query: Exp<"links">) => L[])

Inherited from DeepClientInstance.useMinilinksSubscription

- Defined in work/deeplinks/deeplinks/imports/client.tsx:434

### `Optional` valuesSelectReturning

valuesSelectReturning?: string

Inherited from DeepClientInstance.valuesSelectReturning

- Defined in work/deeplinks/deeplinks/imports/client.tsx:381

##
Methods

### Traveler

- Traveler(links): Traveler

- #### Parameters

  - links: Link<Id>[]

  #### Returns Traveler

  Inherited from DeepClientInstance.Traveler

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:439

### await

- await(id): Promise<boolean>

- #### Parameters

  - id: Id

  #### Returns Promise<boolean>

  Inherited from DeepClientInstance.await

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:410

### can

- can(objectIds, subjectIds, actionIds): Promise<boolean>

- #### Parameters

  - objectIds: Id[]
  - subjectIds: Id[]
  - actionIds: Id[]

  #### Returns Promise<boolean>

  Inherited from DeepClientInstance.can

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:428

### delete

- delete<TTable>(exp, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends
    | "links"
    | "numbers"
    | "strings"
    | "objects"

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  Inherited from DeepClientInstance.delete

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:404

### guest

- guest(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientGuestOptions

  #### Returns Promise<DeepClientAuthResult>

  Inherited from DeepClientInstance.guest

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:420

### id

- id(start, ...path): Promise<Id>

- #### Parameters

  - start:
    | string
    | number
    | QueryLink
    | Id[]
  - `Rest`...path: DeepClientPathItem[]

  #### Returns Promise<Id>

  Inherited from DeepClientInstance.id

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:417

### idLocal

- idLocal(start, ...path): Id

- #### Parameters

  - start: DeepClientStartItem
  - `Rest`...path: DeepClientPathItem[]

  #### Returns Id

  Inherited from DeepClientInstance.idLocal

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:418

### insert

- insert<TTable, LL>(objects, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends
    | "links"
    | "numbers"
    | "strings"
    | "objects"
  - LL = L

  #### Parameters

  - objects: InsertObjects<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  Inherited from DeepClientInstance.insert

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:400

### jwt

- jwt(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  Inherited from DeepClientInstance.jwt

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:422

### login

- login(options): Promise<DeepClientAuthResult>

- #### Parameters

  - options: DeepClientJWTOptions

  #### Returns Promise<DeepClientAuthResult>

  Inherited from DeepClientInstance.login

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:424

### logout

- logout(): Promise<DeepClientAuthResult>

- #### Returns Promise<DeepClientAuthResult>

  Inherited from DeepClientInstance.logout

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:426

### reserve

- reserve<LL>(count): Promise<Id[]>

- #### Type Parameters

  - LL = L

  #### Parameters

  - count: number

  #### Returns Promise<Id[]>

  Inherited from DeepClientInstance.reserve

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:408

### select

- select<TTable, LL>(exp, options?): Promise<DeepClientResult<number | LL[]>>

- #### Type Parameters

  - TTable extends
    | "links"
    | "can"
    | "tree"
    | "selectors"
    | "numbers"
    | "strings"
    | "objects"
    | "handlers"
  - LL = L

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: ReadOptions<TTable>

  #### Returns Promise<DeepClientResult<number | LL[]>>

  Inherited from DeepClientInstance.select

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:397

### serial

- serial(options): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Parameters

  - options: AsyncSerialParams

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  Inherited from DeepClientInstance.serial

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:406

### serializeQuery

- serializeQuery(exp, env?): any

- #### Parameters

  - exp: any
  - `Optional` env: string

  #### Returns any

  Inherited from DeepClientInstance.serializeQuery

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:414

### serializeWhere

- serializeWhere(exp, env?): any

- #### Parameters

  - exp: any
  - `Optional` env: string

  #### Returns any

  Inherited from DeepClientInstance.serializeWhere

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:413

### stringify

- stringify(any?): string

- #### Parameters

  - `Optional` any: any

  #### Returns string

  Inherited from DeepClientInstance.stringify

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:395

### subscribe

- subscribe<TTable, LL>(exp, options?): Observable<number | LL[]>

- #### Type Parameters

  - TTable extends
    | "links"
    | "can"
    | "tree"
    | "selectors"
    | "numbers"
    | "strings"
    | "objects"
    | "handlers"
  - LL = L

  #### Parameters

  - exp: Exp<TTable>
  - `Optional` options: ReadOptions<TTable>

  #### Returns Observable<number | LL[]>

  Inherited from DeepClientInstance.subscribe

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:398

### unvertualizeId

- unvertualizeId(id): Id

- #### Parameters

  - id: Id

  #### Returns Id

  Inherited from DeepClientInstance.unvertualizeId

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:415

### update

- update<TTable>(exp, value, options?): Promise<DeepClientResult<{
  id: any;
  }[]>>

- #### Type Parameters

  - TTable extends
    | "links"
    | "numbers"
    | "strings"
    | "objects"

  #### Parameters

  - exp: Exp<TTable>
  - value: UpdateValue<TTable>
  - `Optional` options: WriteOptions<TTable>

  #### Returns Promise<DeepClientResult<{
  id: any;
  }[]>>

  Inherited from DeepClientInstance.update

  - Defined in work/deeplinks/deeplinks/imports/client.tsx:402